#!/usr/bin/env python3
from gi.repository import GLib
from pydbus import SystemBus
import os
import getpass
import socket
import subprocess
import time
bus2=SystemBus()
loop = GLib.MainLoop()
def get_host_name():
    """获取当前用户名"""
    username = getpass.getuser()
    return  username

def get_host_time():
    """获取本机时间
    return: time_1
    """
    time_1=time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
    return time_1

def get_host_ip():
    """
    查询本机ip地址
    :return: ip
    """
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        s.connect(('8.8.8.8', 80))
        ip = s.getsockname()[0]
    except Exception:
        return "127.0.0.1"
    return ip
class PhoneService(object):
    """
        <node>
            <interface name='com.kylin.kysdk.PhoneControl'>
                <method name='GetStatus'>
                <arg type='i' name='status' direction='out'/>
                </method>
                <method name='SetStatus'>
                <arg type='i' name='status' direction='in'/>
                <arg type='i' name='ret' direction='out'/>
                </method>
            </interface>
        </node>
    """
    def GetStatus(self):
        if os.path.exists('/etc/phone.perm') & os.path.exists('/etc/read.perm'):
            return 2
        elif os.path.exists('/etc/phone.perm') &(not os.path.exists('/etc/read.perm')):
            return 1
        elif not (os.path.exists('/etc/phone.perm') or os.path.exists('/etc/read.perm')):
            return 0
    def SetStatus(self,status):
        if status ==0:
            if os.path.exists('/etc/phone.perm'):
                os.remove('/etc/phone.perm')
            if os.path.exists('/etc/read.perm'):
                os.remove('/etc/read.perm')
            try:
                os.system("pkill gvfsd-mtp")
                os.system("pkill gvfsd-gphoto2")
            except:
                return -1
            return 0
        elif status == 1:
            if os.path.exists('/etc/read.perm'):
                os.remove('/etc/read.perm')
            with open('/etc/phone.perm','w') as f:
                f.write('1')
            return 0
        elif status== 2:
            with open('/etc/phone.perm','w') as f:
                f.write('1')
            with open('/etc/read.perm', 'w') as f:
                f.write('1')
            return 0
        else:
            return -1
bus = SystemBus()
bus.publish("com.kylin.kysdk.PhoneControl", PhoneService())
loop.run()
